Index: gcc/testsuite/g++.dg/tsan/aligned_vs_unaligned_race.C
===================================================================
--- gcc/testsuite/g++.dg/tsan/aligned_vs_unaligned_race.C	(revision 219198)
+++ gcc/testsuite/g++.dg/tsan/aligned_vs_unaligned_race.C	(working copy)
@@ -1,11 +1,15 @@
+/* { dg-additional-sources "lib.c" } */
 /* { dg-shouldfail "tsan" } */
 #include <pthread.h>
 #include <stdio.h>
 #include <stdint.h>
 
+void step(int);
+
 uint64_t Global[2];
 
 void *Thread1(void *x) {
+  step (2);
   Global[1]++;
   return NULL;
 }
@@ -15,6 +19,7 @@ void *Thread2(void *x) {
   struct __attribute__((packed, aligned(1))) u_uint64_t { uint64_t val; };
   u_uint64_t *p4 = reinterpret_cast<u_uint64_t *>(p1 + 1);
   (*p4).val++;
+  step (1);
   return NULL;
 }
 
Index: gcc/testsuite/g++.dg/tsan/atomic_free.C
===================================================================
--- gcc/testsuite/g++.dg/tsan/atomic_free.C	(revision 219198)
+++ gcc/testsuite/g++.dg/tsan/atomic_free.C	(working copy)
@@ -1,10 +1,13 @@
+/* { dg-additional-sources "lib.c" } */
 /* { dg-shouldfail "tsan" } */
 
 #include <pthread.h>
-#include <unistd.h>
 
+void step(int);
+
 void *Thread(void *a) {
   __atomic_fetch_add((int*)a, 1, __ATOMIC_SEQ_CST);
+  step (1);
   return 0;
 }
 
@@ -12,7 +15,7 @@ int main() {
   int *a = new int(0);
   pthread_t t;
   pthread_create(&t, 0, Thread, a);
-  sleep(1);
+  step (2);
   delete a;
   pthread_join(t, 0);
 }
Index: gcc/testsuite/g++.dg/tsan/atomic_free2.C
===================================================================
--- gcc/testsuite/g++.dg/tsan/atomic_free2.C	(revision 219198)
+++ gcc/testsuite/g++.dg/tsan/atomic_free2.C	(working copy)
@@ -1,10 +1,12 @@
+/* { dg-additional-sources "lib.c" } */
 /* { dg-shouldfail "tsan" } */
 
 #include <pthread.h>
-#include <unistd.h>
 
+void step(int);
+
 void *Thread(void *a) {
-  sleep(1);
+  step (2);
   __atomic_fetch_add((int*)a, 1, __ATOMIC_SEQ_CST);
   return 0;
 }
@@ -14,6 +16,7 @@ int main() {
   pthread_t t;
   pthread_create(&t, 0, Thread, a);
   delete a;
+  step (1);
   pthread_join(t, 0);
 }
 
Index: gcc/testsuite/g++.dg/tsan/benign_race.C
===================================================================
--- gcc/testsuite/g++.dg/tsan/benign_race.C	(revision 219198)
+++ gcc/testsuite/g++.dg/tsan/benign_race.C	(working copy)
@@ -1,7 +1,9 @@
+/* { dg-additional-sources "lib.c" } */
 #include <pthread.h>
 #include <stdio.h>
-#include <unistd.h>
 
+void step(int);
+
 int Global;
 int WTFGlobal;
 
@@ -17,6 +19,7 @@ void WTFAnnotateBenignRaceSized(const char *f, int
 void *Thread(void *x) {
   Global = 42;
   WTFGlobal = 142;
+  step (1);
   return 0;
 }
 
@@ -28,7 +31,7 @@ int main() {
                              "Race on WTFGlobal");
   pthread_t t;
   pthread_create(&t, 0, Thread, 0);
-  sleep(1);
+  step (2);
   Global = 43;
   WTFGlobal = 143;
   pthread_join(t, 0);
Index: gcc/testsuite/g++.dg/tsan/lib.c
===================================================================
--- gcc/testsuite/g++.dg/tsan/lib.c	(revision 0)
+++ gcc/testsuite/g++.dg/tsan/lib.c	(working copy)
@@ -0,0 +1,10 @@
+/* { dg-do compile } */
+/* { dg-options "-O2 -fno-sanitize=all" } */
+ 
+static volatile int serial = 0;
+ 
+void step (int i)
+{
+  while (__atomic_load_n (&serial, __ATOMIC_ACQUIRE) != i - 1);
+  __atomic_store_n (&serial, i, __ATOMIC_RELEASE);
+}
